#include <mysql/mysql.h>
#include "auto_break.h"
#include "stralloc.h"

extern MYSQL_ROW do_query(stralloc *query);
extern MYSQL_RES *result;

int checkuser_mysql(char *username, int i) {
  MYSQL_ROW row;
  int j;
  stralloc qmail_mysql_query = { 0 };
  stralloc user = { 0 };

  if (! stralloc_ready(&user, i)) return -1;
  if (! stralloc_catb(&user, username, i)) {
    stralloc_free(&user);
    return -1;
  }
  user.s[i] = '\0';
  if (! make_query(&qmail_mysql_query, user.s)) {
    stralloc_free(&user);
    return -1;
  }

  stralloc_free(&user);
  row = do_query(&qmail_mysql_query);

  switch ((int) row) {
    case -1: return -1; break;
    case 0:
      for (j = i - 1; j > 0; j--) {
        if (*(username + j) == *auto_break) return checkuser_mysql(username, j);
      }
      return 0;
      break;
  }
  mysql_free_result(result);
  return 1;
}
