#include "mysql_queries.h"
#include "stralloc.h"

int make_query(stralloc *query, char *username) {
  int i, len;
  stralloc user = { 0 };

  i = 2 * str_len(username) + 1;
  if (! stralloc_ready(&user, i)) return 0;
  mysql_escape_string(user.s, username, str_len(username));

  len = str_len(QUERY) + user.len + 2;
  if (! stralloc_ready(query, len)) { stralloc_free(&user); return 0; }
  if (! stralloc_cats(query, QUERY)) { stralloc_free(&user); return 0; }
  if (! stralloc_cats(query, user.s)) { stralloc_free(&user); return 0; }
  stralloc_free(&user);
  if (! stralloc_cats(query, "'")) return 0;
  if (! stralloc_0(query)) return 0;
  return 1;
}
