#include <mysql/mysql.h>
#include "control.h"
#include "mysql_queries.h"
#include "stralloc.h"

extern int connect_mysql();

extern MYSQL dbh, *mysql;
extern MYSQL_RES *result;

extern MYSQL_ROW do_query(stralloc *query);

/* qmail-smtpd needs to know if it can accept delivery for this domain */
int rcpthosts_mysql(char *addr, int len) {
  char *host;
  int i, num;
  MYSQL_ROW row;
  stralloc real_host = { 0 };
  stralloc qmail_mysql_query = { 0 };

  /* maybe the client's so slow we lost the MySQL connection... */
  if (! connect_mysql()) return -1;

  num = len;
  host = addr + len;
  while (*host != '@') {
    host--;
    num--;
    if (host == addr) break;
  }

  /* no @ => envnoathost */
  if (num == 0) return 1;

  /* let's lose the @ we found and adjust len */
  host++;

  if (! stralloc_ready(&real_host, 2 * str_len(host) + 1)) return -1;
  mysql_escape_string(real_host.s, host, str_len(host));

#define OOF {\
  stralloc_free(&real_host);\
  stralloc_free(&qmail_mysql_query);\
  return -1;\
}
  len = real_host.len + str_len(RCPTHOSTS) + 2;
  if (! stralloc_ready(&qmail_mysql_query, len)) OOF
  if (! stralloc_cats(&qmail_mysql_query, RCPTHOSTS)) OOF
  if (! stralloc_cats(&qmail_mysql_query, real_host.s)) OOF
  if (! stralloc_cats(&qmail_mysql_query, "'")) OOF
  if (! stralloc_0(&qmail_mysql_query)) OOF
  stralloc_free(&real_host);

  row = do_query(&qmail_mysql_query);

  if ((int) row == 0) return -1;

  num = atoi(row[0]);
  mysql_free_result(result);

  return num;
}
